<?php

	namespace Envia\Orders\Actions;

	defined( 'ABSPATH' ) || exit;

class Envia_Orders {

	public static function print_envia_bulk_action( $actions ) {
		$actions['send_to_envia'] = __( 'Shipping actions - Envia.com', 'woocommerce' );
		return $actions;
	}

	public static function send_to_envia_order_manager( $redirect_to, $action, $post_ids ) { 
		if ( 'send_to_envia' !== $action ) {
			return $redirect_to; // Exit
		}
		$ids = '';
		foreach ( $post_ids as $key => $orderId ) {
			$ids .= count( $post_ids ) == $key + 1 ? $orderId  : $orderId . ',';
		}
		$redirect_to = '/wp-admin/admin.php?page=envia-order-manager&ids=' . $ids;
		return $redirect_to;
	}

	public static function print_envia_meta_box( $screen_id, $post ) {
		$orderStatus = method_exists( $post, 'get_status' ) ? $post->get_status() : $post->post_status;
		if ( self::validate_order_status( $orderStatus ) ) {
			$orderId = method_exists( $post, 'get_id' ) ? $post->get_id() : $post->ID ;
			$allowScreens = array( 'shop_order', 'woocommerce_page_wc-orders' );
			foreach ( $allowScreens as $screenId ) {
				if ( $screen_id == $screenId ) {
					add_meta_box(
						'envia-order-manager',
						__( 'Generate or quote a new shipping label' ),
						array( __CLASS__, 'render_envia_meta_box' ),
						$screen_id,
						'normal',
						'high',
						array( 'orderId' => $orderId )
					);
				}
			}
		}
	}

	public static function validate_order_status( $status ) {
		$notStatus = array( 'completed', 'cancelled' );
		foreach ( $notStatus as $value ) {
			if ( stripos( $status, $value ) !== false ) {
				return false;
			}
		}
		return true;
	}

	public static function render_envia_meta_box( $post, $args ) {
		echo "<div class = 'envia-meta-box'>
			<div class = 'meta-envia-container'>
				<img height ='30px' src='" . esc_url( ENVIA_S3 ) . "/uploads/images/logo-enviapaqueteria.png' alt='envia.com'>
				<p>
				<b>The order is ready to generate a quote and be shipping</b>
				</p>
			</div>
			<div class = 'meta-envia-button'>
				<a id = 'envia-quote-shipping' href='/wp-admin/admin.php?page=envia-order-manager&id=" . esc_html( $args['args']['orderId'] ) . "'> Quote and shipping </a>
			</div>
		</div>" . PHP_EOL;
		wp_enqueue_script( 'orderBox', plugins_url( '../admin/js/enviaOrders.js', __FILE__ ), array(), '1.1', false );
	}
}
